/*
	(Кодировка)
*/
angular.module('app', []).controller('indexController', ['$scope', indexController]);

function hrListToBootstrapTreeview(list, parentId){
	return list.filter(x=>parentId ? x.parent_id==parentId : !x.parent_id).map(function(x){
		var rs = {
			id: x.id,
			text: x.title
		}
		var subNodes =hrListToBootstrapTreeview(list, x.id)
		if (subNodes.length)
			rs.nodes = subNodes;
		return rs;
	})
}

function indexController($scope){
	var self = $scope;
	self.$ctrl = self;
	
	self.DATA = {
		/*
			[{id, parent_id, title}, ...]
		*/
		 hrList: 	null
		,hrMap:		null
		,selHr:		null
		/*
			[{"id": "eap",  "title": "Энергия акт.",    "eu": "кВт*ч"}, ... ]
		*/
		,qtList: 	null
		,qtMap: 	null
		,selQt:		null

		,ivlTypesList: 	null
		,ivlTypesMap: 	null
		
		,allIvlNb:		1
		,allIvlType:	'D'
		,subIvlNb:		1
		,subIvlType:	'h'
		,onlyFinished:	true
	}
	
	self.update = async function(){
		// [{id, title, fmt}, ...]
		ivl_types = await ajax_get ('/www/ivl_types.json');
		self.DATA.ivlTypesList = ivl_types;
		self.DATA.ivlTypesMap = to_map (ivl_types, 'id');
		/*
			[{id, title, parent_id}, ...]
		*/
		var d = await ajax_get ('/enum_hr.json');

		$('#hr').treeview({
			 data: hrListToBootstrapTreeview( d )
			,multiSelect: true
		});

		self.DATA.hrList = d.map(function(x){
			return {
				 id: x.id
				,title: x.title
				,parent_id: x.parent_id
			}
		});
		self.DATA.hrMap = to_map(d, 'id');
		/*
			[{id, title, eu}, ...]
		*/
		var d = await ajax_get ('/enum_qt.json?cumulative=1');
		self.DATA.qtList = d.map(function(x){
			return {
				 id: x.id
				,title: x.title
				,eu: x.eu
			}
		});
		self.DATA.qtMap = to_map(d, 'id');
		
		$scope.$apply ();
	}
	self.update ();

	self.onQtSelected = async function(qt){
		self.DATA.selQt = qt;
	}

	self.read = async function(){
		
		var selected_hr_nodes = $('#hr').treeview('getSelected');
		if ( selected_hr_nodes.length == 0 ){
			console.warn ('Hr not selected');
			alert ('Выберите объекты учета');
			return;
		}
		var hr_ids = selected_hr_nodes.map(x=>x.id);

			// Qt
		var qt = self.DATA.selQt
		if ( !qt ){
			console.warn ('Qt not selected');
			alert ('Выберите параметр');
			return;
		}
		var qt_id = qt.id;

		var allIvl = '' + self.DATA.allIvlNb + self.DATA.allIvlType;
		var subIvl = '' + self.DATA.subIvlNb + self.DATA.subIvlType;
		var finished = self.DATA.onlyFinished;
		
		/*
        	d:{
				start: 'iso-date'
				readouts: ['iso-date', ...]
				series:[
					{hr_id, qt_id, values:[1,2,3]}
				]
        	}
		*/
		var d = await ajax_get ('/read.json?hr=' + hr_ids.join(',') + '&qt=' + qt_id + '&all_ivl=' + allIvl + '&sub_ivl=' + subIvl + '&finished=' + (finished ? '1' : '0'))
		console.log ( d )

		var chart = await ajax_get ('/www/energy_chart.json');
		chart.series = [];

		dtm_format = self.DATA.ivlTypesMap[ self.DATA.subIvlType ].fmt;
		x_axis = d.readouts.map (x => the_time.formatDateTime (the_time.parseDate ( x ), dtm_format) )

		d.series.forEach (function(s){
			/*h = hr;
			serie_title = h.title;
			while ( h.parent_id ){
				h = self.DATA.hrMap[ h.parent_id ];
				serie_title = h.title + '/' + serie_title;
			}*/

			var chartSerie = {
				type: 'column',
				title: self.DATA.hrMap[ s.hr_id ].title + ' / ' + self.DATA.qtMap[ qt_id ].title,
				data: []
			}
			chart.series.push ( chartSerie );

			for (var i = 0; i < x_axis.length; i++){
				chartSerie.data.push ( [x_axis[i], s.values[i] ] )
			}	
		})

		$('#chart').jqChart(chart);
		self.drawTable ( chart.series )
	}

	self.drawTable = function (dataPack){
		console.warn ( 'a')
	}
}

